# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class NetworkSourceForecastInput(BaseModel):
    """
    NetworkSourceForecastInput
    """ # noqa: E501
    source_network_id: StrictStr = Field(description="SourceNetworkId the well belongs to", alias="sourceNetworkId")
    source_network_source_id: StrictStr = Field(description="Source ID for the well definition. This sourceID enables upsert functionality from client source systems of record", alias="sourceNetworkSourceId")
    forecast_valid_date: datetime = Field(description="Date the forecast becomes valid. Datetime offset (with timezone) in ISO 8601 format. Example: 2022-09-27T16:28:37+0000", alias="forecastValidDate")
    var_date: datetime = Field(description="Date of the forecasted rates. Datetime offset (with timezone) in ISO 8601 format. Example: 2022-09-27T16:28:37+0000", alias="date")
    oil_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Forecasted oil rate, STB/d", alias="oilRate")
    gas_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Forecasted gas rate, Mscf/d", alias="gasRate")
    water_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Forecasted water rate, STB/d", alias="waterRate")
    __properties: ClassVar[List[str]] = ["sourceNetworkId", "sourceNetworkSourceId", "forecastValidDate", "date", "oilRate", "gasRate", "waterRate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkSourceForecastInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if oil_rate (nullable) is None
        # and model_fields_set contains the field
        if self.oil_rate is None and "oil_rate" in self.model_fields_set:
            _dict['oilRate'] = None

        # set to None if gas_rate (nullable) is None
        # and model_fields_set contains the field
        if self.gas_rate is None and "gas_rate" in self.model_fields_set:
            _dict['gasRate'] = None

        # set to None if water_rate (nullable) is None
        # and model_fields_set contains the field
        if self.water_rate is None and "water_rate" in self.model_fields_set:
            _dict['waterRate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkSourceForecastInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceNetworkId": obj.get("sourceNetworkId"),
            "sourceNetworkSourceId": obj.get("sourceNetworkSourceId"),
            "forecastValidDate": obj.get("forecastValidDate"),
            "date": obj.get("date"),
            "oilRate": obj.get("oilRate"),
            "gasRate": obj.get("gasRate"),
            "waterRate": obj.get("waterRate")
        })
        return _obj


