# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class TimeSeriesHistoryInput(BaseModel):
    """
    TimeSeriesHistoryInput
    """ # noqa: E501
    source_well_id: StrictStr = Field(description="SourceWellId of the owner of the time series data", alias="sourceWellId")
    source_time_series_id: StrictStr = Field(description="SourceTimeSeriesId, i.e. the tag/configuration ID", alias="sourceTimeSeriesId")
    timestamp: datetime = Field(description="DateTimeOffset of the record. Datetime offset (with timezone) in ISO 8601 format. Example: 2022-09-27T16:28:37+0000")
    value: Union[StrictFloat, StrictInt] = Field(description="Value of the record in the units of measure of the tag/configuration")
    __properties: ClassVar[List[str]] = ["sourceWellId", "sourceTimeSeriesId", "timestamp", "value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeSeriesHistoryInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeSeriesHistoryInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceWellId": obj.get("sourceWellId"),
            "sourceTimeSeriesId": obj.get("sourceTimeSeriesId"),
            "timestamp": obj.get("timestamp"),
            "value": obj.get("value")
        })
        return _obj


