# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class TimeSeriesInput(BaseModel):
    """
    TimeSeriesInput
    """ # noqa: E501
    source_well_id: StrictStr = Field(description="SourceWellId of the time series tag/configuration", alias="sourceWellId")
    source_id: StrictStr = Field(description="Tag identifier. Example: OSI PI AF '\\\\server\\\\element\\\\attributeID'", alias="sourceId")
    measurement: StrictStr = Field(description="CHOKE - PERCENT (choke opening) WHP - PSIG (wellhead / tubing pressure) WHT - FARENHEIT (wellhead / tubing temperature) CHP - PSIG (casing pressure) DHGP - PSIG (downhole gauge pressure) DHGT - FARENHEIT (downhole gauge temperature) OILRATE - STB_PER_DAY (oil rate) GASRATE - MSCF_PER_DAY (gas rate) GASLIFTINJECTIONRATE - MSCF_PER_DAY (gas lift injection rate) WATERRATE - STB_PER_DAY (water rate) SANDRATE - GRAMS_PER_SECOND (sand rate) PRESSUREUPSTREAM - PSIG (upstream choke pressure) PRESSUREDOWNSTREAM - PSIG (downstream choke pressure)")
    unit: StrictStr = Field(description="Unit of Measure. Should match the correct UoM for the measurement.")
    __properties: ClassVar[List[str]] = ["sourceWellId", "sourceId", "measurement", "unit"]

    @field_validator('measurement')
    def measurement_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['CHOKE', 'WHP', 'WHT', 'DHGP', 'DHGT', 'OILRATE', 'GASRATE', 'WATERRATE', 'CONDRATE', 'SANDRATE', 'SANDIND', 'PRESSUREUPSTREAM', 'PRESSUREDOWNSTREAM', 'GASLIFTINJECTIONRATE', 'CHP', 'WELLCYCLINGFLAG']):
            raise ValueError("must be one of enum values ('CHOKE', 'WHP', 'WHT', 'DHGP', 'DHGT', 'OILRATE', 'GASRATE', 'WATERRATE', 'CONDRATE', 'SANDRATE', 'SANDIND', 'PRESSUREUPSTREAM', 'PRESSUREDOWNSTREAM', 'GASLIFTINJECTIONRATE', 'CHP', 'WELLCYCLINGFLAG')")
        return value

    @field_validator('unit')
    def unit_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['PERCENT', 'SIXTY_FOURTHS', 'DEGREES', 'RADIANS', 'PPM', 'RB_PER_DAY', 'INVERSE_PSI', 'PSIG', 'PSIA', 'PSIA_PER_BARREL', 'PSIA_PER_SCF', 'PSIA_PER_MSCF', 'PSIA_PER_MMSCF', 'BARG', 'BARA', 'BARA_PER_BARREL', 'BARA_PER_SCF', 'BARA_PER_MSCF', 'BARA_PER_MMSCF', 'PSI_PER_FOOT', 'PSI_PER_METER', 'STB_PER_DAY', 'STB_PER_DAY_PER_PSIA', 'CUBIC_METER_PER_DAY', 'BBL', 'SCF', 'SCF_PER_DAY', 'SCF_PER_STB', 'MSCF', 'MMSCF', 'MSCF_PER_DAY', 'MSCF_PER_STB', 'MMSCF_PER_STB', 'MMSCF_PER_DAY', 'MSCF_PER_DAY_PER_PSIA', 'MMSCF_PER_DAY_PER_PSIA', 'FARENHEIT', 'CELSIUS', 'STB', 'FEET', 'INCHES', 'METERS', 'MILLIMETERS', 'KILOMETERS', 'DARCY', 'MILLIDARCY_METERS', 'MILLIDARCY_FEET', 'POUNDS_HOUR', 'GRAMS_PER_SECOND', 'HP', 'HZ', 'AMPS', 'VOLTS', 'SPM', 'HOURS', 'LBF', 'GRAVITATIONAL_CONSTANT', 'FEET_PER_SECOND', 'METERS_PER_SECOND']):
            raise ValueError("must be one of enum values ('PERCENT', 'SIXTY_FOURTHS', 'DEGREES', 'RADIANS', 'PPM', 'RB_PER_DAY', 'INVERSE_PSI', 'PSIG', 'PSIA', 'PSIA_PER_BARREL', 'PSIA_PER_SCF', 'PSIA_PER_MSCF', 'PSIA_PER_MMSCF', 'BARG', 'BARA', 'BARA_PER_BARREL', 'BARA_PER_SCF', 'BARA_PER_MSCF', 'BARA_PER_MMSCF', 'PSI_PER_FOOT', 'PSI_PER_METER', 'STB_PER_DAY', 'STB_PER_DAY_PER_PSIA', 'CUBIC_METER_PER_DAY', 'BBL', 'SCF', 'SCF_PER_DAY', 'SCF_PER_STB', 'MSCF', 'MMSCF', 'MSCF_PER_DAY', 'MSCF_PER_STB', 'MMSCF_PER_STB', 'MMSCF_PER_DAY', 'MSCF_PER_DAY_PER_PSIA', 'MMSCF_PER_DAY_PER_PSIA', 'FARENHEIT', 'CELSIUS', 'STB', 'FEET', 'INCHES', 'METERS', 'MILLIMETERS', 'KILOMETERS', 'DARCY', 'MILLIDARCY_METERS', 'MILLIDARCY_FEET', 'POUNDS_HOUR', 'GRAMS_PER_SECOND', 'HP', 'HZ', 'AMPS', 'VOLTS', 'SPM', 'HOURS', 'LBF', 'GRAVITATIONAL_CONSTANT', 'FEET_PER_SECOND', 'METERS_PER_SECOND')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeSeriesInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeSeriesInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceWellId": obj.get("sourceWellId"),
            "sourceId": obj.get("sourceId"),
            "measurement": obj.get("measurement"),
            "unit": obj.get("unit")
        })
        return _obj


